package website.quiz;

import java.util.List;
import java.util.ArrayList;
import java.util.Random;

public class Quiz {
    private static Random rng = new Random();
    private int maxTries;
    private List<QuizQuestion> questions;
    private int questionIndex;
    private boolean wrong;
    private int numTries;
    private Integer answer;
    private int start, end;
    public Quiz() {
        questionIndex = 0;
        numTries = 0;
    }
    public int getMaxTries() {
        return maxTries;
    }
    public void setMaxTries(int maxTries) {
        this.maxTries = maxTries;
    }
    public void setQuestions(List<QuizQuestion> questions) {
        this.questions = questions;
        updateStartEnd();
    }
    public int getNumQuestions() {
        return questions.size();
    }
    public QuizQuestion getQuestion() {
        return questions.get(questionIndex);
    }
    public int getQuestionIndex() {
        return questionIndex;
    }
    public boolean getWrong() {
        return wrong;
    }
    public Integer getAnswer() {
        return null;
    }
    public void setAnswer(Integer answer) {
        this.answer = answer;
    }
    public String answerQuestion() {
        if(questions.get(questionIndex).getAnswer() == answer.intValue()) {
            questionIndex++;
            if(questionIndex >= questions.size()) {
                return "completed";
            } else {
                updateStartEnd();
                wrong = false;
                return "continue";
            }
        } else {
            numTries++;
            if(numTries >= maxTries) {
                return "failed";
            } else {
                wrong = true;
                return "continue";
            }
        }
    }
    public int getStart() {
        return start;
    }
    public int getEnd() {
        return end;
    }
    private void updateStartEnd() {
        start = Math.max(questions.get(questionIndex).getAnswer() - rng.nextInt(5), 0);
        end = start + 4;
    }
}
